#!/bin/bash

wmax=20

usage_exit() {
    echo "$0"
    exit
}

while getopts a: OPT; do
    case $OPT in
      a)
        ws=()
        IFS=$'\n'
        ws=( $( redis-cli --raw --scan --pattern "${OPTARG}*" | head -$((${wmax}+1)) ) )
        if [ ${#ws[@]} -eq 1 ]; then
            echo ${ws[0]}
            redis-cli --raw smembers "${ws[0]}"
       elif [ ${#ws[@]} -gt ${wmax} ]; then
            echo "more than ${wmax} words matched. Needs more focus."
            exit 1
        elif [ ${#ws[@]} -gt 1 ]; then
            PS3="Which word? "
            select w in ${ws[@]}; do
                echo $w
                redis-cli --raw smembers "$w"
            done
        else
            echo "No match."
            exit 1
        fi
        exit 0
        ;;

        \?) usage_exit ;;
    esac
done
shift $((OPTIND - 1))

echo "${1}"
redis-cli --raw smembers "${1}"

